/* Functions to read and store gene trees */

#include <stdio.h>
#include <math.h>
#include "main.h"

int FindParentIS(int target) {

  int i, j, parent=0;
  
  for (j=0; j<2; j++) {
    for (i=0; i<nspecies; i++) {
      if (ppTwoRowS[j][i]==target) {
	parent = i+nspecies+1;
	break;
      }
    }
  }

  /*if (parent==0) { 
     printf("Could not find parent for node %d\n",target); 
     }*/
  return(parent);

}


int NextNodeS(int next) {

  int stop=0;

  while (stop!=1) {
    if (filled_indS[next+1-(nspecies+1)] != 1) {
      next+=1;
      stop=1;
    }
    else next+=1;
  }
  return next;

}

double ReadLengthS(FILE *fp) {

  float length=0.0;

  fscanf(fp,"%14f",&length);
  return (double)length;

}

int AddToNodeS(int current,int next,int last_tip,FILE *fp,double read_length) {

  int sss, junk, i, j, k, ss2, ss3, toadd;
  double temp;
  char sname[15];

  sss = fgetc(fp);

  if (ppTwoRowS[0][current-(nspecies+1)] == 0) i = 0;
  else i=1;

  if (i==0) {

    ppTwoRowS[i][current-(nspecies+1)] = last_tip;
    ppLengthMatS[current][last_tip] = ppLengthMatS[last_tip][current] = read_length;

    if (sss!='(') {

      ss2 = sss;
      sname[0] = ss2;
      //sname[1] = 00;
      //printf("sname is %s\n",sname);
      //printf("It really is\n");
      //fflush(0);
      j=0;
      while (ss2 != ':') {
        ss2=fgetc(fp);
        j++;
        sname[j] = ss2;
      }
      sname[j] = 00;
      
      k=0;
      while (strcmp(sname,speciesname[k])!=0) k++;
      
      toadd = k+1;
      temp = ReadLengthS(fp);

      ppTwoRowS[1][current-(nspecies+1)] = toadd;
      ppLengthMatS[current][toadd] = ppLengthMatS[toadd][current] = temp;
      sss = fgetc(fp);
      filled_indS[current-(nspecies+1)] = 1;
      
    }

  }

  if (i==1 && sss!='(') {


    ss2=sss;
    sname[0] = ss2;
    j=0;
    while (ss2 != ':') {
      ss2=fgetc(fp);
      j++;
      sname[j]=ss2;
    }
    sname[j]=00;

    k=0;
    while (strcmp(sname,speciesname[k])!=0) k++;
    
    toadd = k+1;
    temp = ReadLengthS(fp);
   
    ppTwoRowS[1][current-(nspecies+1)] = toadd;
    ppLengthMatS[current][toadd] = ppLengthMatS[toadd][current] = temp;
    filled_ind[current-(nspecies+1)] = 1;
    sss = fgetc(fp);

  }

  return sss;

}

int FindLastOpenS(int current) {

  int node, stop=0;

  node = current-1;
  while(node>=nspecies+1 && stop==0) {
    if (filled_indS[node-(nspecies+1)]==1) node = node-1;
    else stop=1;
  }
  return node;

}

int CloseBackS(int open, int current, int last_char, int last_tipp, FILE *fp, double read_length) {

  int sss;
  int j;

  sss=getc(fp);

  if (sss!=';') {
  
    if (ppTwoRowS[0][open-(nspecies+1)] == 0) j=0;
    else {
      
      j=1;
      filled_indS[open-(nspecies+1)] = 1;
      
    }
    
    if (sss == ':') {

      read_length = ReadLengthS(fp);
      sss = fgetc(fp);

    }
      
    ppTwoRowS[j][open-(nspecies+1)] = current;  
    ppLengthMatS[open][current] = ppLengthMatS[current][open] = read_length;
   
  }
    
  return sss;
 
}

double ReadSpeciesTree(FILE *fp) {

  int i, j, k;
  int ss=0, ss2, ss3, last_ss, lastlast_ss, last_tip=0;
  int next_avail = nspecies+1, last_open=nspecies+1, curr_node=nspecies+1;
  int parent;
  double read_length=0.0;
  float rate;
  char sname[15];

  for (i=0; i<nspecies; i++) ppTwoRowS[0][i] = ppTwoRowS[1][i] = 0;

  while (ss!='(') ss=fgetc(fp);
  last_ss = ss;
  ss = fgetc(fp);


  while (!feof(fp) && ss!=';') {

    if (ss == '(') {

      next_avail = NextNodeS(next_avail);
      curr_node = next_avail;
      last_ss = ss;
      ss = fgetc(fp);

    }

    else {

      if (ss == ',') {

	last_ss = ss;
	ss = AddToNodeS(curr_node,next_avail,last_tip,fp,read_length);
    
      }

      else {

	if (ss == ')') {

	  last_open = FindLastOpenS(curr_node);
	  lastlast_ss = last_ss;
	  last_ss = ss;
	  ss = CloseBackS(last_open,curr_node,lastlast_ss,last_tip,fp,read_length);
	  if (ss!=';' && filled_indS[last_open-(nspecies+1)]==1) curr_node = FindParentIS(curr_node);
	  else curr_node = last_open;
	 	  
	}
	
	else {
	  
	  ss2=ss;
	  sname[0] = ss;
	  //sname[1] = 00;
	  //printf("sname is %s\n",sname);
	  //printf("It really is\n");
	  //fflush(0);

	  j=0;
	  while (ss2 != ':') {
	    ss2=fgetc(fp);
	    j++;
	    sname[j] = ss2;
	  }
	  sname[j] = 00;

	  k=0;
	  while (strcmp(sname,speciesname[k])!=0) k++;
	  last_tip = k+1;

	  last_ss = last_tip;
	  ss = ss2;
	  if (ss == ':') read_length = ReadLengthS(fp);
	  parent = FindParentIS(last_tip);
	  if (parent != 0) ppLengthMatS[parent][last_tip] = ppLengthMatS[last_tip][parent] = read_length;
	  ss = fgetc(fp);

	}

      }

    }
      
  }


  return rate;
}

